stages:
  - Quality
  - Test
  - Prepare
  - Release

variables:
  GIT_SUBMODULE_STRATEGY: recursive

Shell check:
  image: koalaman/shellcheck-alpine:stable
  stage: Quality
  before_script:
    - shellcheck --version
  script:
    - cd app ; shellcheck fireflex lib/*.sh

shfmt:
  image: mvdan/shfmt:latest-alpine
  stage: Quality
  before_script:
    - shfmt -version
  script:
    - cd app; shfmt -i 2 -ci -w fireflex lib/*.sh

Bats:
  image: fedora:40
  stage: Test
  before_script:
    - dnf install make util-linux pcre-tools bats -y
  script:
    - bats test/test.bats

prepare_job:
  stage: Prepare
  image: alpine:latest
  rules:
  - if: '$CI_COMMIT_TAG =~ /^v?\d+\.\d+\.\d+$/'
  script:
    - apk add curl jq
    - 'curl -H "PRIVATE-TOKEN: $CI_API_TOKEN" "$CI_API_V4_URL/projects/$CI_PROJECT_ID/repository/changelog?version=$CI_COMMIT_TAG" | jq -r .notes > release_notes.md'
  artifacts:
    paths:
    - release_notes.md

release_job:
  stage: Release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs:
    - job: prepare_job
      artifacts: true
  rules:
  - if: '$CI_COMMIT_TAG =~ /^v?\d+\.\d+\.\d+$/'
  script:
    - echo "Creating release"
  release:
    name: 'Release $CI_COMMIT_TAG'
    description: release_notes.md
    tag_name: '$CI_COMMIT_TAG'
    ref: '$CI_COMMIT_SHA'
    assets:
      links:
        - name: 'Container Image $CI_COMMIT_TAG'
          url: "https://$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA"

workflow:
  rules:
    # Execute jobs in merge request context.
    - if: $CI_MERGE_REQUEST_ID
    # Execute jobs when a new tag is created.
    - if: $CI_COMMIT_TAG
    # Execute jobs when a new commit is pushed to develop branch.
    - if: $CI_COMMIT_BRANCH == 'develop'
    # Execute jobs when a new commit is pushed to main branch.
    - if: $CI_COMMIT_BRANCH == 'main'
    # Execute jobs on schedule
    - if: $CI_PIPELINE_SOURCE == "schedule"
